.\" Automatically generated by Pandoc 1.19.1
.\"
.TH "PYFLAME" "1" "March 2018" "" ""
.hy
.SH NAME
.PP
pyflame \- A Ptracing Python Profiler
.SH SYNOPSIS
.PP
\f[B]pyflame\f[] [\f[B]options\f[]] [\f[B]\-p\f[]|\f[B]\-\-pid\f[]]
\f[I]PID\f[]
.PP
\f[B]pyflame\f[] [\f[B]options\f[]] [\f[B]\-t\f[]|\f[B]\-\-trace\f[]]
\f[I]command\f[] [\f[I]args\f[]...]
.SH DESCRIPTION
.PP
\f[B]pyflame\f[] is a Python profiler that created flame graphs.
It uses \f[B]ptrace\f[](2) to extract stack information.
The output of \f[B]pyflame\f[] is intended to be used with Brendan
Gregg\[aq]s \f[I]flamegraph.pl\f[] script, which can be found on GitHub
at <https://github.com/brendangregg/FlameGraph>.
.SH GENERAL OPTIONS
.PP
There are two invocation forms.
When \f[B]\-p\f[] \f[I]PID\f[] is used, pyflame will attach to the
running process specified by \f[I]PID\f[] to collect profiling data.
The meaning of this option is analogous to its meaning in commands like
\f[B]strace\f[](1) or \f[B]gdb\f[](1).
.PP
When \f[B]\-t\f[] is given, pyflame will instead go into "trace mode".
In this mode, it interprets the rest of the command line as a command to
run, and traces the command to completion.
This is analogous to how \f[B]strace\f[](1) works when a PID is not
specified.
.TP
.B \f[B]\-d\f[], \f[B]\-\-dump\f[]
Dump stacks from all threads (implies \f[B]\-\-threads\f[]).
.RS
.RE
.TP
.B \f[B]\-h\f[], \f[B]\-\-help\f[]
Display a friendly help message.
.RS
.RE
.TP
.B \f[B]\-o\f[], \f[B]\-\-output\f[]=\f[I]FILENAME\f[]
Write profiling output to \f[I]FILENAME\f[] (otherwise stdout is used).
.RS
.RE
.TP
.B \f[B]\-p\f[], \f[B]\-\-pid\f[]=\f[I]PID\f[]
Specify which \f[I]PID\f[] to trace.
.RS
.PP
Older versions of pyflame received \f[I]PID\f[] as a positional
argument, where \f[I]PID\f[] was interpreted as the last argument.
This usage mode still works, but is considered deprecated.
You should use \f[B]\-p\f[] or \f[B]\-\-pid\f[] when specifying
\f[I]PID\f[].
.RE
.TP
.B \f[B]\-s\f[], \f[B]\-\-seconds\f[]=\f[I]SECONDS\f[]
Profile the process for duration \f[I]SECONDS\f[] before detaching.
The default is to profile for 1 second.
This option is not compatible with trace mode.
.RS
.RE
.TP
.B \f[B]\-r\f[], \f[B]\-\-rate\f[]=\f[I]RATE\f[]
Sample the process at this frequency.
The argument \f[I]RATE\f[] is interpreted as a fractional value,
measured in seconds.
For example, \f[B]\-r 0.1\f[] would mean to sample the process every 0.1
seconds (i.e.
every 100 milliseconds).
The default value for \f[I]RATE\f[] is 0.01, which samples every ten
milliseconds.
.RS
.PP
Note that setting a low value for rate will increase the accuracy of
profiles, but it also increases the overhead introduced by pyflame.
The default frequency used by pyflame is relatively aggressive; a less
aggressive value like \f[B]\-r 0.01\f[] may be more appropriate if you
are profiling processes in production.
.RE
.TP
.B \f[B]\-t\f[], \f[B]\-\-trace\f[] \f[I]command\f[] [\f[I]args\f[]...]
Run pyflame in trace mode, which traces the child process until
completion.
If used, this must be the final argument (the rest of the arguments will
be interpreted as a command plus arguments to the command).
This is analogous to \f[B]strace\f[](1) in its default mode.
.RS
.RE
.TP
.B \f[B]\-v\f[], \f[B]\-\-version\f[]
Print the version.
.RS
.RE
.TP
.B \f[B]\-x\f[], \f[B]\-\-exclude\-idle\f[]
Exclude "idle" time from output.
.RS
.RE
.TP
.B \f[B]\-\-threads\f[]
Enable profiling multi\-threaded Python apps.
.RS
.RE
.SS ADVANCED OPTIONS
.PP
The following options are less commonly used.
.TP
.B \f[B]\-\-abi\f[]=\f[I]VERSION\f[]
Force a particular Python ABI.
This option should only be needed in edge cases when profiling embedded
Python builds (e.g.
uWSGI), and only if pyflame doesn\[aq]t automatically detect the correct
ABI.
\f[I]VERSION\f[] should be a two digit integer consisting of the Python
major and minor version, e.g.
27 for Python 2.7 or 36 for Python 3.6.
.RS
.RE
.TP
.B \f[B]\-\-flamechart\f[]
Print the timestamp for each stack.
This is useful for generating "flame chart" profiles.
Generally regular flame graphs are encouraged, since the timestamp flame
charts are harder to use.
.RS
.RE
.SH ONLINE DOCUMENTATION
.PP
You can find the complete documentation online at:
<https://pyflame.readthedocs.io/>.
The online documentation is more comprehensive than this man page, and
includes usage examples.
.SH REPORTING BUGS
.PP
If you find any bugs, please create a new issue on GitHub:
<https://github.com/uber/pyflame>
.SH AUTHORS
Evan Klitzke <evan@eklitzke.org>.
